---
type: api
title: Simulate data ingestion
description: Run ingest pipelines against a set of provided documents, optionally with substitute pipeline definitions, to simulate ingesting data into an index.
url: https://www.elastic.co/docs/api/doc/elasticsearch/v8/operation/operation-simulate-ingest
resource: https://www.elastic.co/docs/api/doc/elasticsearch/v8/operation/operation-simulate-ingest
products:
  - Elasticsearch
---

# Simulate data ingestion

Authentication: required

Availability: Preview since 8.12

## Paths

- `POST` (also `GET`) `/_ingest/{index}/_simulate`
- `POST` (also `GET`) `/_ingest/_simulate`

#### Path parameters

- `index` (string) — optional, leave it out to use `/_ingest/_simulate`
  The index to simulate ingesting into.
This value can be overridden by specifying an index on each document.
If you specify this parameter in the request path, it is used for any documents that do not explicitly specify an index argument.

## Description

Run ingest pipelines against a set of provided documents, optionally with substitute pipeline definitions, to simulate ingesting data into an index.

This API is meant to be used for troubleshooting or pipeline development, as it does not actually index any data into Elasticsearch.

The API runs the default and final pipeline for that index against a set of documents provided in the body of the request.
If a pipeline contains a reroute processor, it follows that reroute processor to the new index, running that index's pipelines as well the same way that a non-simulated ingest would.
No data is indexed into Elasticsearch.
Instead, the transformed document is returned, along with the list of pipelines that have been run and the name of the index where the document would have been indexed if this were not a simulation.
The transformed document is validated against the mappings that would apply to this index, and any validation error is reported in the result.

This API differs from the simulate pipeline API in that you specify a single pipeline for that API, and it runs only that one pipeline.
The simulate pipeline API is more useful for developing a single pipeline, while the simulate ingest API is more useful for troubleshooting the interaction of the various pipelines that get applied when ingesting into an index.

By default, the pipeline definitions that are currently in the system are used.
However, you can supply substitute pipeline definitions in the body of the request.
These will be used in place of the pipeline definitions that are already in the system. This can be used to replace existing pipeline definitions or to create new ones. The pipeline substitutions are used only within this request.

## Required privileges

- Index privileges: `index`

## Query string parameters

- `pipeline` (string) — optional
  The pipeline to use as the default pipeline.
This value can be used to override the default pipeline of the index.

## Request body

`application/json`

- `docs` (object[]) — required
  Sample documents to test in the pipeline.
  - `_id` (string) — optional
    Unique identifier for the document.
This ID must be unique within the `_index`.
  - `_index` (string) — optional
    Name of the index containing the document.
  - `_source` (object) — required
    JSON body for the document.
- `component_template_substitutions` (map string to object) — optional
  A map of component template names to substitute component template definition objects.
  Map values (object)
  - `template` (object) — required
    - `_meta` (object) — optional
    - `version` (number) — optional
    - `settings` (map string to object) — optional
      Map values (object)
      - `index` (object) — optional — recursive
      - `mode` (string) — optional
      - `routing_path` (union string | string[]) — optional
      - `soft_deletes` (object) — optional
        - `enabled` (boolean · default: true) — optional
          Indicates whether soft deletes are enabled on the index.
        - `retention_lease` (object) — optional
          The maximum period to retain a shard history retention lease before it is considered expired.
Shard history retention leases ensure that soft deletes are retained during merges on the Lucene
index. If a soft delete is merged away before it can be replicated to a follower the following
process will fail due to incomplete history on the leader.
          - `period` (union oneOf) — required
            Values: `-1`, `0`
      - `sort` (object) — optional
        - `field` (union oneOf) — optional
          One of: `string[]` or `string`
        - `order` (union enum | enum[]) — optional
          

Supported values include: `asc` (or `ASC`), `desc` (or `DESC`)
          Values: `asc`, `ASC`, `desc`, `DESC`
        - `mode` (union enum | enum[]) — optional
          

Supported values include: `min` (or `MIN`), `max` (or `MAX`)
          Values: `min`, `MIN`, `max`, `MAX`
        - `missing` (union enum | enum[]) — optional
          

Supported values include: `_last`, `_first`
          Values: `_last`, `_first`
      - `number_of_shards` (number | string · default: 1) — optional
      - `number_of_replicas` (number | string · default: 0) — optional
      - `number_of_routing_shards` (number) — optional
      - `check_on_startup` (enum · default: false) — optional
        Values: `true`, `false`, `checksum`
      - `codec` (string · default: LZ4) — optional
      - `routing_partition_size` (number | string · default: 1) — optional
      - `load_fixed_bitset_filters_eagerly` (boolean · default: true) — optional
      - `hidden` (boolean | string · default: false) — optional
      - `auto_expand_replicas` (union string · default: false) — optional — nullable
      - `merge` (object) — optional
        - `scheduler` (object) — optional
          - `max_thread_count` (number | string) — optional
          - `max_merge_count` (number | string) — optional
      - `search` (object) — optional
        - `idle` (object) — optional
          - `after` (union oneOf · default: 30s) — optional
            Values: `-1`, `0`
        - `slowlog` (object) — optional
          - `level` (string) — optional
          - `source` (number) — optional
          - `reformat` (boolean) — optional
          - `threshold` (object) — optional
            - `query` (object) — optional
              - `warn` (union oneOf) — optional
                Values: `-1`, `0`
              - `info` (union oneOf) — optional
                Values: `-1`, `0`
              - `debug` (union oneOf) — optional
                Values: `-1`, `0`
              - `trace` (union oneOf) — optional
                Values: `-1`, `0`
            - `fetch` (object) — optional
              - `warn` (union oneOf) — optional
                Values: `-1`, `0`
              - `info` (union oneOf) — optional
                Values: `-1`, `0`
              - `debug` (union oneOf) — optional
                Values: `-1`, `0`
              - `trace` (union oneOf) — optional
                Values: `-1`, `0`
      - `refresh_interval` (union oneOf · default: 1s) — optional
        Values: `-1`, `0`
      - `max_result_window` (number | string · default: 10000) — optional
      - `max_inner_result_window` (number · default: 100) — optional
      - `max_rescore_window` (number · default: 10000) — optional
      - `max_docvalue_fields_search` (number · default: 100) — optional
      - `max_script_fields` (number · default: 32) — optional
      - `max_ngram_diff` (number · default: 1) — optional
      - `max_shingle_diff` (number · default: 3) — optional
      - `blocks` (object) — optional
        - `read_only` (boolean | string) — optional
        - `read_only_allow_delete` (boolean | string) — optional
        - `read` (boolean | string) — optional
        - `write` (boolean | string) — optional
        - `metadata` (boolean | string) — optional
      - `max_refresh_listeners` (number) — optional
      - `analyze` (object) — optional
        Settings to define analyzers, tokenizers, token filters and character filters.
        - `max_token_count` (number | string · default: 10000) — optional
      - `highlight` (object) — optional
        - `max_analyzed_offset` (number · default: 1000000) — optional
      - `max_terms_count` (number · default: 65536) — optional
      - `max_regex_length` (number · default: 1000) — optional
      - `routing` (object) — optional
        - `allocation` (object) — optional
          - `enable` (enum) — optional
            Values: `all`, `primaries`, `new_primaries`, `none`
          - `include` (object) — optional
            - `_tier_preference` (string) — optional
            - `_id` (string) — optional
          - `require` (object) — optional
            Assign the index to a node whose attribute has all of the given values.
Each key is a node attribute: one of the built-in attributes `_name`, `_host_ip`, `_publish_ip`, `_ip`, `_host`, `_id` and `_tier`, or a custom node attribute.
Each value is a comma-separated string or an array of strings, and can use wildcards.
          - `initial_recovery` (object) — optional
            - `_id` (string) — optional
          - `disk` (object) — optional
            - `threshold_enabled` (boolean | string) — optional
        - `rebalance` (object) — optional
          - `enable` (enum) — required
            Values: `all`, `primaries`, `replicas`, `none`
      - `unassigned` (object) — optional
        - `node_left` (object) — optional
          - `delayed_timeout` (union oneOf · default: 1m) — optional
            The amount of time to wait for a node that has left before assuming its
shards are permanently missing and starting to allocate replacement replicas.
            Values: `-1`, `0`
      - `gc_deletes` (union oneOf · default: 60s) — optional
        Values: `-1`, `0`
      - `default_pipeline` (string · default: _none) — optional
      - `final_pipeline` (string · default: _none) — optional
      - `lifecycle` (object) — optional
        - `name` (string) — optional
          The name of the policy to use to manage the index. For information about how Elasticsearch applies policy changes, see Policy updates.
        - `indexing_complete` (boolean | string · default: false) — optional
          Indicates whether or not the index has been rolled over. Automatically set to true when ILM completes the rollover action.
You can explicitly set it to skip rollover.
        - `origination_date` (number · default: 0) — optional
          If specified, this is the timestamp used to calculate the index age for its phase transitions. Use this setting
if you create a new index that contains old data and want to use the original creation date to calculate the index
age. Specified as a Unix epoch value in milliseconds.
        - `parse_origination_date` (boolean) — optional
          Set to true to parse the origination date from the index name. This origination date is used to calculate the index age
for its phase transitions. The index name must match the pattern ^.*-{date_format}-\\d+, where the date_format is
yyyy.MM.dd and the trailing digits are optional. An index that was rolled over would normally match the full format,
for example logs-2016.10.31-000002). If the index name doesn’t match the pattern, index creation fails.
        - `step` (object) — optional
          - `wait_time_threshold` (union oneOf) — optional
            Time to wait for the cluster to resolve allocation issues during an ILM shrink action. Must be greater than 1h (1 hour).
See Shard allocation for shrink.
            Values: `-1`, `0`
        - `rollover_alias` (string) — optional
          The index alias to update when the index rolls over. Specify when using a policy that contains a rollover action.
When the index rolls over, the alias is updated to reflect that the index is no longer the write index. For more
information about rolling indices, see Rollover.
        - `prefer_ilm` (boolean | string · default: true) — optional
          Preference for the system that manages a data stream backing index (preferring ILM when both ILM and DLM are
applicable for an index).
      - `provided_name` (string) — optional
      - `creation_date` (union oneOf) — optional
        One of: `number` or `string`
      - `creation_date_string` (union oneOf) — optional
        One of: `string` or `number`
      - `uuid` (string) — optional
      - `version` (object) — optional
        - `created` (string) — optional
        - `created_string` (string) — optional
      - `verified_before_close` (boolean | string) — optional
      - `format` (number | string) — optional
      - `max_slices_per_scroll` (number) — optional
      - `translog` (object) — optional
        - `sync_interval` (union oneOf · default: 5s) — optional
          How often the translog is fsynced to disk and committed, regardless of write operations.
Values less than 100ms are not allowed.
          Values: `-1`, `0`
        - `durability` (enum · default: string) — optional
          Whether or not to `fsync` and commit the translog after every index, delete, update, or bulk request.

Supported values include:
  - `request` (or `REQUEST`): (default) fsync and commit after every request. In the event of hardware failure, all acknowledged writes
will already have been committed to disk.
  - `async` (or `ASYNC`): fsync and commit in the background every sync_interval. In the event of a failure, all acknowledged writes
since the last automatic commit will be discarded.
          Values: `request`, `REQUEST`, `async`, `ASYNC`
        - `flush_threshold_size` (number | string · default: 512mb) — optional
          The translog stores all operations that are not yet safely persisted in Lucene (i.e., are not
part of a Lucene commit point). Although these operations are available for reads, they will need
to be replayed if the shard was stopped and had to be recovered. This setting controls the
maximum total size of these operations, to prevent recoveries from taking too long. Once the
maximum size has been reached a flush will happen, generating a new Lucene commit point.
        - `retention` (object) — optional
          - `size` (number | string · default: 512mb) — optional
            This controls the total size of translog files to keep for each shard. Keeping more translog files increases
the chance of performing an operation based sync when recovering a replica. If the translog files are not
sufficient, replica recovery will fall back to a file based sync. This setting is ignored, and should not be
set, if soft deletes are enabled. Soft deletes are enabled by default in indices created in Elasticsearch
versions 7.0.0 and later.
          - `age` (union oneOf · default: 12h) — optional
            This controls the maximum duration for which translog files are kept by each shard. Keeping more
translog files increases the chance of performing an operation based sync when recovering replicas. If
the translog files are not sufficient, replica recovery will fall back to a file based sync. This setting
is ignored, and should not be set, if soft deletes are enabled. Soft deletes are enabled by default in
indices created in Elasticsearch versions 7.0.0 and later.
            Values: `-1`, `0`
      - `query_string` (object) — optional
        - `lenient` (boolean | string) — required
      - `priority` (number | string) — optional
      - `top_metrics_max_size` (number) — optional
      - `analysis` (object) — optional
        - `analyzer` (map string to oneOf) — optional
          Map values (union oneOf)
          One of:
          - **type: custom** (`type: custom`)
            - `type` (enum) — required
              Values: `custom`
            - `char_filter` (union string | string[]) — optional
            - `filter` (union string | string[]) — optional
            - `position_increment_gap` (number) — optional
            - `position_offset_gap` (number) — optional
            - `tokenizer` (string) — required
          - **type: fingerprint** (`type: fingerprint`)
            - `type` (enum) — required
              Values: `fingerprint`
            - `version` (string) — optional
            - `max_output_size` (number) — required
            - `preserve_original` (boolean) — required
            - `separator` (string) — required
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string) — optional
          - **type: keyword** (`type: keyword`)
            - `type` (enum) — required
              Values: `keyword`
            - `version` (string) — optional
          - **type: nori** (`type: nori`)
            - `type` (enum) — required
              Values: `nori`
            - `version` (string) — optional
            - `decompound_mode` (enum) — optional
              Values: `discard`, `none`, `mixed`
            - `stoptags` (string[]) — optional
            - `user_dictionary` (string) — optional
          - **type: pattern** (`type: pattern`)
            - `type` (enum) — required
              Values: `pattern`
            - `version` (string) — optional
            - `flags` (string) — optional
            - `lowercase` (boolean) — optional
            - `pattern` (string) — required
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - **type: simple** (`type: simple`)
            - `type` (enum) — required
              Values: `simple`
            - `version` (string) — optional
          - **type: standard** (`type: standard`)
            - `type` (enum) — required
              Values: `standard`
            - `max_token_length` (number) — optional
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - **type: stop** (`type: stop`)
            - `type` (enum) — required
              Values: `stop`
            - `version` (string) — optional
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string) — optional
          - **type: whitespace** (`type: whitespace`)
            - `type` (enum) — required
              Values: `whitespace`
            - `version` (string) — optional
          - **type: icu_analyzer** (`type: icu_analyzer`)
            - `type` (enum) — required
              Values: `icu_analyzer`
            - `method` (enum) — required
              Values: `nfc`, `nfkc`, `nfkc_cf`
            - `mode` (enum) — required
              Values: `decompose`, `compose`
          - **type: kuromoji** (`type: kuromoji`)
            - `type` (enum) — required
              Values: `kuromoji`
            - `mode` (enum) — optional
              Values: `normal`, `search`, `extended`
            - `user_dictionary` (string) — optional
          - **type: snowball** (`type: snowball`)
            - `type` (enum) — required
              Values: `snowball`
            - `version` (string) — optional
            - `language` (enum) — required
              Values: `Arabic`, `Armenian`, `Basque`, `Catalan`, `Danish`, `Dutch`, `English`, `Estonian`, `Finnish`, `French`, `German`, `German2`, `Hungarian`, `Italian`, `Irish`, `Kp`, `Lithuanian`, `Lovins`, `Norwegian`, `Porter`, `Portuguese`, `Romanian`, `Russian`, `Serbian`, `Spanish`, `Swedish`, `Turkish`
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - **type: arabic** (`type: arabic`)
            - `type` (enum) — required
              Values: `arabic`
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string) — optional
            - `stem_exclusion` (string[]) — optional
          - **type: armenian** (`type: armenian`)
            - `type` (enum) — required
              Values: `armenian`
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string) — optional
            - `stem_exclusion` (string[]) — optional
          - **type: basque** (`type: basque`)
            - `type` (enum) — required
              Values: `basque`
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string) — optional
            - `stem_exclusion` (string[]) — optional
          - **type: bengali** (`type: bengali`)
            - `type` (enum) — required
              Values: `bengali`
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string) — optional
            - `stem_exclusion` (string[]) — optional
          - **type: brazilian** (`type: brazilian`)
            - `type` (enum) — required
              Values: `brazilian`
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string) — optional
          - **type: bulgarian** (`type: bulgarian`)
            - `type` (enum) — required
              Values: `bulgarian`
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string) — optional
            - `stem_exclusion` (string[]) — optional
          - **type: catalan** (`type: catalan`)
            - `type` (enum) — required
              Values: `catalan`
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string) — optional
            - `stem_exclusion` (string[]) — optional
          - **type: chinese** (`type: chinese`)
            - `type` (enum) — required
              Values: `chinese`
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string) — optional
          - **type: cjk** (`type: cjk`)
            - `type` (enum) — required
              Values: `cjk`
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string) — optional
          - **type: czech** (`type: czech`)
            - `type` (enum) — required
              Values: `czech`
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string) — optional
            - `stem_exclusion` (string[]) — optional
          - **type: danish** (`type: danish`)
            - `type` (enum) — required
              Values: `danish`
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string) — optional
          - **type: dutch** (`type: dutch`)
            - `type` (enum) — required
              Values: `dutch`
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string) — optional
            - `stem_exclusion` (string[]) — optional
          - **type: english** (`type: english`)
            - `type` (enum) — required
              Values: `english`
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string) — optional
            - `stem_exclusion` (string[]) — optional
          - **type: estonian** (`type: estonian`)
            - `type` (enum) — required
              Values: `estonian`
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string) — optional
          - **type: finnish** (`type: finnish`)
            - `type` (enum) — required
              Values: `finnish`
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string) — optional
            - `stem_exclusion` (string[]) — optional
          - **type: french** (`type: french`)
            - `type` (enum) — required
              Values: `french`
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string) — optional
            - `stem_exclusion` (string[]) — optional
          - **type: galician** (`type: galician`)
            - `type` (enum) — required
              Values: `galician`
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string) — optional
            - `stem_exclusion` (string[]) — optional
          - **type: german** (`type: german`)
            - `type` (enum) — required
              Values: `german`
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string) — optional
            - `stem_exclusion` (string[]) — optional
          - **type: greek** (`type: greek`)
            - `type` (enum) — required
              Values: `greek`
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string) — optional
          - **type: hindi** (`type: hindi`)
            - `type` (enum) — required
              Values: `hindi`
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string) — optional
            - `stem_exclusion` (string[]) — optional
          - **type: hungarian** (`type: hungarian`)
            - `type` (enum) — required
              Values: `hungarian`
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string) — optional
            - `stem_exclusion` (string[]) — optional
          - **type: indonesian** (`type: indonesian`)
            - `type` (enum) — required
              Values: `indonesian`
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string) — optional
            - `stem_exclusion` (string[]) — optional
          - **type: irish** (`type: irish`)
            - `type` (enum) — required
              Values: `irish`
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string) — optional
            - `stem_exclusion` (string[]) — optional
          - **type: italian** (`type: italian`)
            - `type` (enum) — required
              Values: `italian`
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string) — optional
            - `stem_exclusion` (string[]) — optional
          - **type: latvian** (`type: latvian`)
            - `type` (enum) — required
              Values: `latvian`
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string) — optional
            - `stem_exclusion` (string[]) — optional
          - **type: lithuanian** (`type: lithuanian`)
            - `type` (enum) — required
              Values: `lithuanian`
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string) — optional
            - `stem_exclusion` (string[]) — optional
          - **type: norwegian** (`type: norwegian`)
            - `type` (enum) — required
              Values: `norwegian`
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string) — optional
            - `stem_exclusion` (string[]) — optional
          - **type: persian** (`type: persian`)
            - `type` (enum) — required
              Values: `persian`
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string) — optional
          - **type: portuguese** (`type: portuguese`)
            - `type` (enum) — required
              Values: `portuguese`
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string) — optional
            - `stem_exclusion` (string[]) — optional
          - **type: romanian** (`type: romanian`)
            - `type` (enum) — required
              Values: `romanian`
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string) — optional
            - `stem_exclusion` (string[]) — optional
          - **type: russian** (`type: russian`)
            - `type` (enum) — required
              Values: `russian`
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string) — optional
            - `stem_exclusion` (string[]) — optional
          - **type: serbian** (`type: serbian`)
            - `type` (enum) — required
              Values: `serbian`
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string) — optional
            - `stem_exclusion` (string[]) — optional
          - **type: sorani** (`type: sorani`)
            - `type` (enum) — required
              Values: `sorani`
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string) — optional
            - `stem_exclusion` (string[]) — optional
          - **type: spanish** (`type: spanish`)
            - `type` (enum) — required
              Values: `spanish`
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string) — optional
            - `stem_exclusion` (string[]) — optional
          - **type: swedish** (`type: swedish`)
            - `type` (enum) — required
              Values: `swedish`
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string) — optional
            - `stem_exclusion` (string[]) — optional
          - **type: turkish** (`type: turkish`)
            - `type` (enum) — required
              Values: `turkish`
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string) — optional
            - `stem_exclusion` (string[]) — optional
          - **type: thai** (`type: thai`)
            - `type` (enum) — required
              Values: `thai`
            - `stopwords` (union oneOf) — optional
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string) — optional
        - `char_filter` (map string to oneOf) — optional
          Map values (union oneOf)
          One of:
          - **string**
          - **CharFilterDefinition**
            One of:
            - **type: html_strip** (`type: html_strip`)
              - `type` (enum) — required
                Values: `html_strip`
              - `version` (string) — optional
              - `escaped_tags` (string[]) — optional
            - **type: mapping** (`type: mapping`)
              - `type` (enum) — required
                Values: `mapping`
              - `version` (string) — optional
              - `mappings` (string[]) — optional
              - `mappings_path` (string) — optional
            - **type: pattern_replace** (`type: pattern_replace`)
              - `type` (enum) — required
                Values: `pattern_replace`
              - `version` (string) — optional
              - `flags` (string) — optional
              - `pattern` (string) — required
              - `replacement` (string) — optional
            - **type: icu_normalizer** (`type: icu_normalizer`)
              - `type` (enum) — required
                Values: `icu_normalizer`
              - `version` (string) — optional
              - `mode` (enum) — optional
                Values: `decompose`, `compose`
              - `name` (enum) — optional
                Values: `nfc`, `nfkc`, `nfkc_cf`
              - `unicode_set_filter` (string) — optional
            - **type: kuromoji_iteration_mark** (`type: kuromoji_iteration_mark`)
              - `type` (enum) — required
                Values: `kuromoji_iteration_mark`
              - `version` (string) — optional
              - `normalize_kana` (boolean) — required
              - `normalize_kanji` (boolean) — required
        - `filter` (map string to oneOf) — optional
          Map values (union oneOf)
          One of:
          - **string**
          - **TokenFilterDefinition**
            One of:
            - **type: apostrophe** (`type: apostrophe`)
              - `type` (enum) — required
                Values: `apostrophe`
              - `version` (string) — optional
            - **type: arabic_stem** (`type: arabic_stem`)
              - `type` (enum) — required
                Values: `arabic_stem`
              - `version` (string) — optional
            - **type: arabic_normalization** (`type: arabic_normalization`)
              - `type` (enum) — required
                Values: `arabic_normalization`
              - `version` (string) — optional
            - **type: asciifolding** (`type: asciifolding`)
              - `type` (enum) — required
                Values: `asciifolding`
              - `version` (string) — optional
              - `preserve_original` (boolean | string) — optional
                If `true`, emit both original tokens and folded tokens. Defaults to `false`.
            - **type: bengali_normalization** (`type: bengali_normalization`)
              - `type` (enum) — required
                Values: `bengali_normalization`
              - `version` (string) — optional
            - **type: brazilian_stem** (`type: brazilian_stem`)
              - `type` (enum) — required
                Values: `brazilian_stem`
              - `version` (string) — optional
            - **type: cjk_bigram** (`type: cjk_bigram`)
              - `type` (enum) — required
                Values: `cjk_bigram`
              - `version` (string) — optional
              - `ignored_scripts` (enum[]) — optional
                Array of character scripts for which to disable bigrams.
                Values: `han`, `hangul`, `hiragana`, `katakana`
              - `output_unigrams` (boolean) — optional
                If `true`, emit tokens in both bigram and unigram form. If `false`, a CJK character is output in unigram form when it has no adjacent characters. Defaults to `false`.
            - **type: cjk_width** (`type: cjk_width`)
              - `type` (enum) — required
                Values: `cjk_width`
              - `version` (string) — optional
            - **type: classic** (`type: classic`)
              - `type` (enum) — required
                Values: `classic`
              - `version` (string) — optional
            - **type: common_grams** (`type: common_grams`)
              - `type` (enum) — required
                Values: `common_grams`
              - `version` (string) — optional
              - `common_words` (string[]) — optional
                A list of tokens. The filter generates bigrams for these tokens.
Either this or the `common_words_path` parameter is required.
              - `common_words_path` (string) — optional
                Path to a file containing a list of tokens. The filter generates bigrams for these tokens.
This path must be absolute or relative to the `config` location. The file must be UTF-8 encoded. Each token in the file must be separated by a line break.
Either this or the `common_words` parameter is required.
              - `ignore_case` (boolean) — optional
                If `true`, matches for common words matching are case-insensitive. Defaults to `false`.
              - `query_mode` (boolean) — optional
                If `true`, the filter excludes the following tokens from the output:
- Unigrams for common words
- Unigrams for terms followed by common words
Defaults to `false`. We recommend enabling this parameter for search analyzers.
            - **type: condition** (`type: condition`)
              - `type` (enum) — required
                Values: `condition`
              - `version` (string) — optional
              - `filter` (string[]) — required
                Array of token filters. If a token matches the predicate script in the `script` parameter, these filters are applied to the token in the order provided.
              - `script` (string) — required
                Predicate script used to apply token filters. If a token matches this script, the filters in the `filter` parameter are applied to the token.
            - **type: czech_stem** (`type: czech_stem`)
              - `type` (enum) — required
                Values: `czech_stem`
              - `version` (string) — optional
            - **type: decimal_digit** (`type: decimal_digit`)
              - `type` (enum) — required
                Values: `decimal_digit`
              - `version` (string) — optional
            - **type: delimited_payload** (`type: delimited_payload`)
              - `type` (enum) — required
                Values: `delimited_payload`
              - `version` (string) — optional
              - `delimiter` (string) — optional
                Character used to separate tokens from payloads. Defaults to `|`.
              - `encoding` (enum) — optional
                Data type for the stored payload.
                Values: `int`, `float`, `identity`
            - **type: dutch_stem** (`type: dutch_stem`)
              - `type` (enum) — required
                Values: `dutch_stem`
              - `version` (string) — optional
            - **type: edge_ngram** (`type: edge_ngram`)
              - `type` (enum) — required
                Values: `edge_ngram`
              - `version` (string) — optional
              - `max_gram` (number) — optional
                Maximum character length of a gram. For custom token filters, defaults to `2`. For the built-in edge_ngram filter, defaults to `1`.
              - `min_gram` (number) — optional
                Minimum character length of a gram. Defaults to `1`.
              - `side` (enum) — optional
                Indicates whether to truncate tokens from the `front` or `back`. Defaults to `front`.
                Values: `front`, `back`
              - `preserve_original` (boolean | string) — optional
                Emits original token when set to `true`. Defaults to `false`.
            - **type: elision** (`type: elision`)
              - `type` (enum) — required
                Values: `elision`
              - `version` (string) — optional
              - `articles` (string[]) — optional
                List of elisions to remove.
To be removed, the elision must be at the beginning of a token and be immediately followed by an apostrophe. Both the elision and apostrophe are removed.
For custom `elision` filters, either this parameter or `articles_path` must be specified.
              - `articles_path` (string) — optional
                Path to a file that contains a list of elisions to remove.
This path must be absolute or relative to the `config` location, and the file must be UTF-8 encoded. Each elision in the file must be separated by a line break.
To be removed, the elision must be at the beginning of a token and be immediately followed by an apostrophe. Both the elision and apostrophe are removed.
For custom `elision` filters, either this parameter or `articles` must be specified.
              - `articles_case` (boolean | string) — optional
                If `true`, elision matching is case insensitive. If `false`, elision matching is case sensitive. Defaults to `false`.
            - **type: fingerprint** (`type: fingerprint`)
              - `type` (enum) — required
                Values: `fingerprint`
              - `version` (string) — optional
              - `max_output_size` (number) — optional
                Maximum character length, including whitespace, of the output token. Defaults to `255`. Concatenated tokens longer than this will result in no token output.
              - `separator` (string) — optional
                Character to use to concatenate the token stream input. Defaults to a space.
            - **type: flatten_graph** (`type: flatten_graph`)
              - `type` (enum) — required
                Values: `flatten_graph`
              - `version` (string) — optional
            - **type: french_stem** (`type: french_stem`)
              - `type` (enum) — required
                Values: `french_stem`
              - `version` (string) — optional
            - **type: german_normalization** (`type: german_normalization`)
              - `type` (enum) — required
                Values: `german_normalization`
              - `version` (string) — optional
            - **type: german_stem** (`type: german_stem`)
              - `type` (enum) — required
                Values: `german_stem`
              - `version` (string) — optional
            - **type: hindi_normalization** (`type: hindi_normalization`)
              - `type` (enum) — required
                Values: `hindi_normalization`
              - `version` (string) — optional
            - **type: hunspell** (`type: hunspell`)
              - `type` (enum) — required
                Values: `hunspell`
              - `version` (string) — optional
              - `dedup` (boolean) — optional
                If `true`, duplicate tokens are removed from the filter’s output. Defaults to `true`.
              - `dictionary` (string) — optional
                One or more `.dic` files (e.g, `en_US.dic`, my_custom.dic) to use for the Hunspell dictionary.
By default, the `hunspell` filter uses all `.dic` files in the `<$ES_PATH_CONF>/hunspell/<locale>` directory specified using the `lang`, `language`, or `locale` parameter.
              - `locale` (string) — required
                Locale directory used to specify the `.aff` and `.dic` files for a Hunspell dictionary.
              - `longest_only` (boolean) — optional
                If `true`, only the longest stemmed version of each token is included in the output. If `false`, all stemmed versions of the token are included. Defaults to `false`.
            - **type: hyphenation_decompounder** (`type: hyphenation_decompounder`)
              - `type` (enum) — required
                Values: `hyphenation_decompounder`
              - `version` (string) — optional
              - `max_subword_size` (number) — optional
                Maximum subword character length. Longer subword tokens are excluded from the output. Defaults to `15`.
              - `min_subword_size` (number) — optional
                Minimum subword character length. Shorter subword tokens are excluded from the output. Defaults to `2`.
              - `min_word_size` (number) — optional
                Minimum word character length. Shorter word tokens are excluded from the output. Defaults to `5`.
              - `only_longest_match` (boolean) — optional
                If `true`, only include the longest matching subword. Defaults to `false`.
              - `word_list` (string[]) — optional
                A list of subwords to look for in the token stream. If found, the subword is included in the token output.
Either this parameter or `word_list_path` must be specified.
              - `word_list_path` (string) — optional
                Path to a file that contains a list of subwords to find in the token stream. If found, the subword is included in the token output.
This path must be absolute or relative to the config location, and the file must be UTF-8 encoded. Each token in the file must be separated by a line break.
Either this parameter or `word_list` must be specified.
              - `hyphenation_patterns_path` (string) — required
                Path to an Apache FOP (Formatting Objects Processor) XML hyphenation pattern file.
This path must be absolute or relative to the `config` location. Only FOP v1.2 compatible files are supported.
              - `no_sub_matches` (boolean) — optional
                If `true`, do not match sub tokens in tokens that are in the word list. Defaults to `false`.
              - `no_overlapping_matches` (boolean) — optional
                If `true`, do not allow overlapping tokens. Defaults to `false`.
            - **type: indic_normalization** (`type: indic_normalization`)
              - `type` (enum) — required
                Values: `indic_normalization`
              - `version` (string) — optional
            - **type: keep_types** (`type: keep_types`)
              - `type` (enum) — required
                Values: `keep_types`
              - `version` (string) — optional
              - `mode` (enum) — optional
                Indicates whether to keep or remove the specified token types.
                Values: `include`, `exclude`
              - `types` (string[]) — required
                List of token types to keep or remove.
            - **type: keep** (`type: keep`)
              - `type` (enum) — required
                Values: `keep`
              - `version` (string) — optional
              - `keep_words` (string[]) — optional
                List of words to keep. Only tokens that match words in this list are included in the output.
Either this parameter or `keep_words_path` must be specified.
              - `keep_words_case` (boolean) — optional
                If `true`, lowercase all keep words. Defaults to `false`.
              - `keep_words_path` (string) — optional
                Path to a file that contains a list of words to keep. Only tokens that match words in this list are included in the output.
This path must be absolute or relative to the `config` location, and the file must be UTF-8 encoded. Each word in the file must be separated by a line break.
Either this parameter or `keep_words` must be specified.
            - **type: keyword_marker** (`type: keyword_marker`)
              - `type` (enum) — required
                Values: `keyword_marker`
              - `version` (string) — optional
              - `ignore_case` (boolean) — optional
                If `true`, matching for the `keywords` and `keywords_path` parameters ignores letter case. Defaults to `false`.
              - `keywords` (union string | string[]) — optional
                Array of keywords. Tokens that match these keywords are not stemmed.
This parameter, `keywords_path`, or `keywords_pattern` must be specified. You cannot specify this parameter and `keywords_pattern`.
              - `keywords_path` (string) — optional
                Path to a file that contains a list of keywords. Tokens that match these keywords are not stemmed.
This path must be absolute or relative to the `config` location, and the file must be UTF-8 encoded. Each word in the file must be separated by a line break.
This parameter, `keywords`, or `keywords_pattern` must be specified. You cannot specify this parameter and `keywords_pattern`.
              - `keywords_pattern` (string) — optional
                Java regular expression used to match tokens. Tokens that match this expression are marked as keywords and not stemmed.
This parameter, `keywords`, or `keywords_path` must be specified. You cannot specify this parameter and `keywords` or `keywords_pattern`.
            - **type: keyword_repeat** (`type: keyword_repeat`)
              - `type` (enum) — required
                Values: `keyword_repeat`
              - `version` (string) — optional
            - **type: kstem** (`type: kstem`)
              - `type` (enum) — required
                Values: `kstem`
              - `version` (string) — optional
            - **type: length** (`type: length`)
              - `type` (enum) — required
                Values: `length`
              - `version` (string) — optional
              - `max` (number) — optional
                Maximum character length of a token. Longer tokens are excluded from the output. Defaults to `Integer.MAX_VALUE`, which is `2^31-1` or `2147483647`.
              - `min` (number) — optional
                Minimum character length of a token. Shorter tokens are excluded from the output. Defaults to `0`.
            - **type: limit** (`type: limit`)
              - `type` (enum) — required
                Values: `limit`
              - `version` (string) — optional
              - `consume_all_tokens` (boolean) — optional
                If `true`, the limit filter exhausts the token stream, even if the `max_token_count` has already been reached. Defaults to `false`.
              - `max_token_count` (number | string) — optional
                Maximum number of tokens to keep. Once this limit is reached, any remaining tokens are excluded from the output. Defaults to `1`.
            - **type: lowercase** (`type: lowercase`)
              - `type` (enum) — required
                Values: `lowercase`
              - `version` (string) — optional
              - `language` (enum) — optional
                Language-specific lowercase token filter to use.
                Values: `greek`, `irish`, `turkish`
            - **type: min_hash** (`type: min_hash`)
              - `type` (enum) — required
                Values: `min_hash`
              - `version` (string) — optional
              - `bucket_count` (number) — optional
                Number of buckets to which hashes are assigned. Defaults to `512`.
              - `hash_count` (number) — optional
                Number of ways to hash each token in the stream. Defaults to `1`.
              - `hash_set_size` (number) — optional
                Number of hashes to keep from each bucket. Defaults to `1`.
Hashes are retained by ascending size, starting with the bucket’s smallest hash first.
              - `with_rotation` (boolean) — optional
                If `true`, the filter fills empty buckets with the value of the first non-empty bucket to its circular right if the `hash_set_size` is `1`. If the `bucket_count` argument is greater than 1, this parameter defaults to `true`. Otherwise, this parameter defaults to `false`.
            - **type: multiplexer** (`type: multiplexer`)
              - `type` (enum) — required
                Values: `multiplexer`
              - `version` (string) — optional
              - `filters` (string[]) — required
                A list of token filters to apply to incoming tokens.
              - `preserve_original` (boolean | string) — optional
                If `true` (the default) then emit the original token in addition to the filtered tokens.
            - **type: ngram** (`type: ngram`)
              - `type` (enum) — required
                Values: `ngram`
              - `version` (string) — optional
              - `max_gram` (number) — optional
                Maximum length of characters in a gram. Defaults to `2`.
              - `min_gram` (number) — optional
                Minimum length of characters in a gram. Defaults to `1`.
              - `preserve_original` (boolean | string) — optional
                Emits original token when set to `true`. Defaults to `false`.
            - **type: nori_part_of_speech** (`type: nori_part_of_speech`)
              - `type` (enum) — required
                Values: `nori_part_of_speech`
              - `version` (string) — optional
              - `stoptags` (string[]) — optional
                An array of part-of-speech tags that should be removed.
            - **type: pattern_capture** (`type: pattern_capture`)
              - `type` (enum) — required
                Values: `pattern_capture`
              - `version` (string) — optional
              - `patterns` (string[]) — required
                A list of regular expressions to match.
              - `preserve_original` (boolean | string) — optional
                If set to `true` (the default) it will emit the original token.
            - **type: pattern_replace** (`type: pattern_replace`)
              - `type` (enum) — required
                Values: `pattern_replace`
              - `version` (string) — optional
              - `all` (boolean) — optional
                If `true`, all substrings matching the pattern parameter’s regular expression are replaced. If `false`, the filter replaces only the first matching substring in each token. Defaults to `true`.
              - `flags` (string) — optional
              - `pattern` (string) — required
                Regular expression, written in Java’s regular expression syntax. The filter replaces token substrings matching this pattern with the substring in the `replacement` parameter.
              - `replacement` (string) — optional
                Replacement substring. Defaults to an empty substring (`""`).
            - **type: persian_normalization** (`type: persian_normalization`)
              - `type` (enum) — required
                Values: `persian_normalization`
              - `version` (string) — optional
            - **type: persian_stem** (`type: persian_stem`)
              - `type` (enum) — required
                Values: `persian_stem`
              - `version` (string) — optional
            - **type: porter_stem** (`type: porter_stem`)
              - `type` (enum) — required
                Values: `porter_stem`
              - `version` (string) — optional
            - **type: predicate_token_filter** (`type: predicate_token_filter`)
              - `type` (enum) — required
                Values: `predicate_token_filter`
              - `version` (string) — optional
              - `script` (string) — required
                Script containing a condition used to filter incoming tokens. Only tokens that match this script are included in the output.
            - **type: remove_duplicates** (`type: remove_duplicates`)
              - `type` (enum) — required
                Values: `remove_duplicates`
              - `version` (string) — optional
            - **type: reverse** (`type: reverse`)
              - `type` (enum) — required
                Values: `reverse`
              - `version` (string) — optional
            - **type: russian_stem** (`type: russian_stem`)
              - `type` (enum) — required
                Values: `russian_stem`
              - `version` (string) — optional
            - **type: scandinavian_folding** (`type: scandinavian_folding`)
              - `type` (enum) — required
                Values: `scandinavian_folding`
              - `version` (string) — optional
            - **type: scandinavian_normalization** (`type: scandinavian_normalization`)
              - `type` (enum) — required
                Values: `scandinavian_normalization`
              - `version` (string) — optional
            - **type: serbian_normalization** (`type: serbian_normalization`)
              - `type` (enum) — required
                Values: `serbian_normalization`
              - `version` (string) — optional
            - **type: shingle** (`type: shingle`)
              - `type` (enum) — required
                Values: `shingle`
              - `version` (string) — optional
              - `filler_token` (string) — optional
                String used in shingles as a replacement for empty positions that do not contain a token. This filler token is only used in shingles, not original unigrams. Defaults to an underscore (`_`).
              - `max_shingle_size` (number | string) — optional
                Maximum number of tokens to concatenate when creating shingles. Defaults to `2`.
              - `min_shingle_size` (number | string) — optional
                Minimum number of tokens to concatenate when creating shingles. Defaults to `2`.
              - `output_unigrams` (boolean) — optional
                If `true`, the output includes the original input tokens. If `false`, the output only includes shingles; the original input tokens are removed. Defaults to `true`.
              - `output_unigrams_if_no_shingles` (boolean) — optional
                If `true`, the output includes the original input tokens only if no shingles are produced; if shingles are produced, the output only includes shingles. Defaults to `false`.
              - `token_separator` (string) — optional
                Separator used to concatenate adjacent tokens to form a shingle. Defaults to a space (`" "`).
            - **type: snowball** (`type: snowball`)
              - `type` (enum) — required
                Values: `snowball`
              - `version` (string) — optional
              - `language` (enum) — optional
                Controls the language used by the stemmer.
                Values: `Arabic`, `Armenian`, `Basque`, `Catalan`, `Danish`, `Dutch`, `English`, `Estonian`, `Finnish`, `French`, `German`, `German2`, `Hungarian`, `Italian`, `Irish`, `Kp`, `Lithuanian`, `Lovins`, `Norwegian`, `Porter`, `Portuguese`, `Romanian`, `Russian`, `Serbian`, `Spanish`, `Swedish`, `Turkish`
            - **type: sorani_normalization** (`type: sorani_normalization`)
              - `type` (enum) — required
                Values: `sorani_normalization`
              - `version` (string) — optional
            - **type: stemmer_override** (`type: stemmer_override`)
              - `type` (enum) — required
                Values: `stemmer_override`
              - `version` (string) — optional
              - `rules` (string[]) — optional
                A list of mapping rules to use.
              - `rules_path` (string) — optional
                A path (either relative to `config` location, or absolute) to a list of mappings.
            - **type: stemmer** (`type: stemmer`)
              - `type` (enum) — required
                Values: `stemmer`
              - `version` (string) — optional
              - `language` (string) — optional
            - **type: stop** (`type: stop`)
              - `type` (enum) — required
                Values: `stop`
              - `version` (string) — optional
              - `ignore_case` (boolean) — optional
                If `true`, stop word matching is case insensitive. For example, if `true`, a stop word of the matches and removes `The`, `THE`, or `the`. Defaults to `false`.
              - `remove_trailing` (boolean) — optional
                If `true`, the last token of a stream is removed if it’s a stop word. Defaults to `true`.
              - `stopwords` (union oneOf) — optional
                Language value, such as `_arabic_` or `_thai_`. Defaults to `_english_`.
                Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
              - `stopwords_path` (string) — optional
                Path to a file that contains a list of stop words to remove.
This path must be absolute or relative to the `config` location, and the file must be UTF-8 encoded. Each stop word in the file must be separated by a line break.
            - **type: synonym_graph** (`type: synonym_graph`)
              - `type` (enum) — required
                Values: `synonym_graph`
              - `version` (string) — optional
              - `expand` (boolean) — optional
                Expands definitions for equivalent synonym rules. Defaults to `true`.
              - `format` (enum) — optional
                Sets the synonym rules format.
                Values: `solr`, `wordnet`
              - `lenient` (boolean) — optional
                If `true` ignores errors while parsing the synonym rules. It is important to note that only those synonym rules which cannot get parsed are ignored. Defaults to the value of the `updateable` setting.
              - `synonyms` (string[]) — optional
                Used to define inline synonyms.
              - `synonyms_path` (string) — optional
                Used to provide a synonym file. This path must be absolute or relative to the `config` location.
              - `synonyms_set` (string) — optional
                Provide a synonym set created via Synonyms Management APIs.
              - `tokenizer` (string) — optional — deprecated
                Controls the tokenizers that will be used to tokenize the synonym, this parameter is for backwards compatibility for indices that created before 6.0.
              - `updateable` (boolean) — optional
                If `true` allows reloading search analyzers to pick up changes to synonym files. Only to be used for search analyzers. Defaults to `false`.
            - **type: synonym** (`type: synonym`)
              - `type` (enum) — required
                Values: `synonym`
              - `version` (string) — optional
              - `expand` (boolean) — optional
                Expands definitions for equivalent synonym rules. Defaults to `true`.
              - `format` (enum) — optional
                Sets the synonym rules format.
                Values: `solr`, `wordnet`
              - `lenient` (boolean) — optional
                If `true` ignores errors while parsing the synonym rules. It is important to note that only those synonym rules which cannot get parsed are ignored. Defaults to the value of the `updateable` setting.
              - `synonyms` (string[]) — optional
                Used to define inline synonyms.
              - `synonyms_path` (string) — optional
                Used to provide a synonym file. This path must be absolute or relative to the `config` location.
              - `synonyms_set` (string) — optional
                Provide a synonym set created via Synonyms Management APIs.
              - `tokenizer` (string) — optional — deprecated
                Controls the tokenizers that will be used to tokenize the synonym, this parameter is for backwards compatibility for indices that created before 6.0.
              - `updateable` (boolean) — optional
                If `true` allows reloading search analyzers to pick up changes to synonym files. Only to be used for search analyzers. Defaults to `false`.
            - **type: trim** (`type: trim`)
              - `type` (enum) — required
                Values: `trim`
              - `version` (string) — optional
            - **type: truncate** (`type: truncate`)
              - `type` (enum) — required
                Values: `truncate`
              - `version` (string) — optional
              - `length` (number) — optional
                Character limit for each token. Tokens exceeding this limit are truncated. Defaults to `10`.
            - **type: unique** (`type: unique`)
              - `type` (enum) — required
                Values: `unique`
              - `version` (string) — optional
              - `only_on_same_position` (boolean) — optional
                If `true`, only remove duplicate tokens in the same position. Defaults to `false`.
            - **type: uppercase** (`type: uppercase`)
              - `type` (enum) — required
                Values: `uppercase`
              - `version` (string) — optional
            - **type: word_delimiter_graph** (`type: word_delimiter_graph`)
              - `type` (enum) — required
                Values: `word_delimiter_graph`
              - `version` (string) — optional
              - `catenate_all` (boolean) — optional
                If `true`, the filter produces catenated tokens for chains of alphanumeric characters separated by non-alphabetic delimiters. Defaults to `false`.
              - `catenate_numbers` (boolean) — optional
                If `true`, the filter produces catenated tokens for chains of numeric characters separated by non-alphabetic delimiters. Defaults to `false`.
              - `catenate_words` (boolean) — optional
                If `true`, the filter produces catenated tokens for chains of alphabetical characters separated by non-alphabetic delimiters. Defaults to `false`.
              - `generate_number_parts` (boolean) — optional
                If `true`, the filter includes tokens consisting of only numeric characters in the output. If `false`, the filter excludes these tokens from the output. Defaults to `true`.
              - `generate_word_parts` (boolean) — optional
                If `true`, the filter includes tokens consisting of only alphabetical characters in the output. If `false`, the filter excludes these tokens from the output. Defaults to `true`.
              - `preserve_original` (boolean | string) — optional
                If `true`, the filter includes the original version of any split tokens in the output. This original version includes non-alphanumeric delimiters. Defaults to `false`.
              - `protected_words` (string[]) — optional
                Array of tokens the filter won’t split.
              - `protected_words_path` (string) — optional
                Path to a file that contains a list of tokens the filter won’t split.
This path must be absolute or relative to the `config` location, and the file must be UTF-8 encoded. Each token in the file must be separated by a line break.
              - `split_on_case_change` (boolean) — optional
                If `true`, the filter splits tokens at letter case transitions. For example: camelCase -> [ camel, Case ]. Defaults to `true`.
              - `split_on_numerics` (boolean) — optional
                If `true`, the filter splits tokens at letter-number transitions. For example: j2se -> [ j, 2, se ]. Defaults to `true`.
              - `stem_english_possessive` (boolean) — optional
                If `true`, the filter removes the English possessive (`'s`) from the end of each token. For example: O'Neil's -> [ O, Neil ]. Defaults to `true`.
              - `type_table` (string[]) — optional
                Array of custom type mappings for characters. This allows you to map non-alphanumeric characters as numeric or alphanumeric to avoid splitting on those characters.
              - `type_table_path` (string) — optional
                Path to a file that contains custom type mappings for characters. This allows you to map non-alphanumeric characters as numeric or alphanumeric to avoid splitting on those characters.
              - `adjust_offsets` (boolean) — optional
                If `true`, the filter adjusts the offsets of split or catenated tokens to better reflect their actual position in the token stream. Defaults to `true`.
              - `ignore_keywords` (boolean) — optional
                If `true`, the filter skips tokens with a keyword attribute of true. Defaults to `false`.
            - **type: word_delimiter** (`type: word_delimiter`)
              - `type` (enum) — required
                Values: `word_delimiter`
              - `version` (string) — optional
              - `catenate_all` (boolean) — optional
                If `true`, the filter produces catenated tokens for chains of alphanumeric characters separated by non-alphabetic delimiters. Defaults to `false`.
              - `catenate_numbers` (boolean) — optional
                If `true`, the filter produces catenated tokens for chains of numeric characters separated by non-alphabetic delimiters. Defaults to `false`.
              - `catenate_words` (boolean) — optional
                If `true`, the filter produces catenated tokens for chains of alphabetical characters separated by non-alphabetic delimiters. Defaults to `false`.
              - `generate_number_parts` (boolean) — optional
                If `true`, the filter includes tokens consisting of only numeric characters in the output. If `false`, the filter excludes these tokens from the output. Defaults to `true`.
              - `generate_word_parts` (boolean) — optional
                If `true`, the filter includes tokens consisting of only alphabetical characters in the output. If `false`, the filter excludes these tokens from the output. Defaults to `true`.
              - `preserve_original` (boolean | string) — optional
                If `true`, the filter includes the original version of any split tokens in the output. This original version includes non-alphanumeric delimiters. Defaults to `false`.
              - `protected_words` (string[]) — optional
                Array of tokens the filter won’t split.
              - `protected_words_path` (string) — optional
                Path to a file that contains a list of tokens the filter won’t split.
This path must be absolute or relative to the `config` location, and the file must be UTF-8 encoded. Each token in the file must be separated by a line break.
              - `split_on_case_change` (boolean) — optional
                If `true`, the filter splits tokens at letter case transitions. For example: camelCase -> [ camel, Case ]. Defaults to `true`.
              - `split_on_numerics` (boolean) — optional
                If `true`, the filter splits tokens at letter-number transitions. For example: j2se -> [ j, 2, se ]. Defaults to `true`.
              - `stem_english_possessive` (boolean) — optional
                If `true`, the filter removes the English possessive (`'s`) from the end of each token. For example: O'Neil's -> [ O, Neil ]. Defaults to `true`.
              - `type_table` (string[]) — optional
                Array of custom type mappings for characters. This allows you to map non-alphanumeric characters as numeric or alphanumeric to avoid splitting on those characters.
              - `type_table_path` (string) — optional
                Path to a file that contains custom type mappings for characters. This allows you to map non-alphanumeric characters as numeric or alphanumeric to avoid splitting on those characters.
            - **type: ja_stop** (`type: ja_stop`)
              - `type` (enum) — required
                Values: `ja_stop`
              - `version` (string) — optional
              - `stopwords` (union oneOf) — optional
                Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - **type: kuromoji_stemmer** (`type: kuromoji_stemmer`)
              - `type` (enum) — required
                Values: `kuromoji_stemmer`
              - `version` (string) — optional
              - `minimum_length` (number) — required
            - **type: kuromoji_readingform** (`type: kuromoji_readingform`)
              - `type` (enum) — required
                Values: `kuromoji_readingform`
              - `version` (string) — optional
              - `use_romaji` (boolean) — required
            - **type: kuromoji_part_of_speech** (`type: kuromoji_part_of_speech`)
              - `type` (enum) — required
                Values: `kuromoji_part_of_speech`
              - `version` (string) — optional
              - `stoptags` (string[]) — required
            - **type: icu_collation** (`type: icu_collation`)
              - `type` (enum) — required
                Values: `icu_collation`
              - `version` (string) — optional
              - `alternate` (enum) — optional
                Values: `shifted`, `non-ignorable`
              - `caseFirst` (enum) — optional
                Values: `lower`, `upper`
              - `caseLevel` (boolean) — optional
              - `country` (string) — optional
              - `decomposition` (enum) — optional
                Values: `no`, `identical`
              - `hiraganaQuaternaryMode` (boolean) — optional
              - `language` (string) — optional
              - `numeric` (boolean) — optional
              - `rules` (string) — optional
              - `strength` (enum) — optional
                Values: `primary`, `secondary`, `tertiary`, `quaternary`, `identical`
              - `variableTop` (string) — optional
              - `variant` (string) — optional
            - **type: icu_folding** (`type: icu_folding`)
              - `type` (enum) — required
                Values: `icu_folding`
              - `version` (string) — optional
              - `unicode_set_filter` (string) — required
            - **type: icu_normalizer** (`type: icu_normalizer`)
              - `type` (enum) — required
                Values: `icu_normalizer`
              - `version` (string) — optional
              - `name` (enum) — required
                Values: `nfc`, `nfkc`, `nfkc_cf`
            - **type: icu_transform** (`type: icu_transform`)
              - `type` (enum) — required
                Values: `icu_transform`
              - `version` (string) — optional
              - `dir` (enum) — optional
                Values: `forward`, `reverse`
              - `id` (string) — required
            - **type: phonetic** (`type: phonetic`)
              - `type` (enum) — required
                Values: `phonetic`
              - `version` (string) — optional
              - `encoder` (enum) — required
                Values: `metaphone`, `double_metaphone`, `soundex`, `refined_soundex`, `caverphone1`, `caverphone2`, `cologne`, `nysiis`, `koelnerphonetik`, `haasephonetik`, `beider_morse`, `daitch_mokotoff`
              - `languageset` (union enum | enum[]) — optional
                

Supported values include: `any`, `common`, `cyrillic`, `english`, `french`, `german`, `hebrew`, `hungarian`, `polish`, `romanian`, `russian`, `spanish`
                Values: `any`, `common`, `cyrillic`, `english`, `french`, `german`, `hebrew`, `hungarian`, `polish`, `romanian`, `russian`, `spanish`
              - `max_code_len` (number) — optional
              - `name_type` (enum) — optional
                Values: `generic`, `ashkenazi`, `sephardic`
              - `replace` (boolean) — optional
              - `rule_type` (enum) — optional
                Values: `approx`, `exact`
            - **type: dictionary_decompounder** (`type: dictionary_decompounder`)
              - `type` (enum) — required
                Values: `dictionary_decompounder`
              - `version` (string) — optional
              - `max_subword_size` (number) — optional
                Maximum subword character length. Longer subword tokens are excluded from the output. Defaults to `15`.
              - `min_subword_size` (number) — optional
                Minimum subword character length. Shorter subword tokens are excluded from the output. Defaults to `2`.
              - `min_word_size` (number) — optional
                Minimum word character length. Shorter word tokens are excluded from the output. Defaults to `5`.
              - `only_longest_match` (boolean) — optional
                If `true`, only include the longest matching subword. Defaults to `false`.
              - `word_list` (string[]) — optional
                A list of subwords to look for in the token stream. If found, the subword is included in the token output.
Either this parameter or `word_list_path` must be specified.
              - `word_list_path` (string) — optional
                Path to a file that contains a list of subwords to find in the token stream. If found, the subword is included in the token output.
This path must be absolute or relative to the config location, and the file must be UTF-8 encoded. Each token in the file must be separated by a line break.
Either this parameter or `word_list` must be specified.
        - `normalizer` (map string to oneOf) — optional
          Map values (union oneOf)
          One of:
          - **type: lowercase** (`type: lowercase`)
            - `type` (enum) — required
              Values: `lowercase`
          - **type: custom** (`type: custom`)
            - `type` (enum) — required
              Values: `custom`
            - `char_filter` (string[]) — optional
            - `filter` (string[]) — optional
        - `tokenizer` (map string to oneOf) — optional
          Map values (union oneOf)
          One of:
          - **string**
          - **TokenizerDefinition**
            One of:
            - **type: char_group** (`type: char_group`)
              - `type` (enum) — required
                Values: `char_group`
              - `version` (string) — optional
              - `tokenize_on_chars` (string[]) — required
              - `max_token_length` (number) — optional
            - **type: classic** (`type: classic`)
              - `type` (enum) — required
                Values: `classic`
              - `version` (string) — optional
              - `max_token_length` (number) — optional
            - **type: edge_ngram** (`type: edge_ngram`)
              - `type` (enum) — required
                Values: `edge_ngram`
              - `version` (string) — optional
              - `custom_token_chars` (string) — optional
              - `max_gram` (number) — optional
              - `min_gram` (number) — optional
              - `token_chars` (enum[] · default: []) — optional
                Values: `letter`, `digit`, `whitespace`, `punctuation`, `symbol`, `custom`
            - **type: keyword** (`type: keyword`)
              - `type` (enum) — required
                Values: `keyword`
              - `version` (string) — optional
              - `buffer_size` (number · default: 256) — optional
            - **type: letter** (`type: letter`)
              - `type` (enum) — required
                Values: `letter`
              - `version` (string) — optional
            - **type: lowercase** (`type: lowercase`)
              - `type` (enum) — required
                Values: `lowercase`
              - `version` (string) — optional
            - **type: ngram** (`type: ngram`)
              - `type` (enum) — required
                Values: `ngram`
              - `version` (string) — optional
              - `custom_token_chars` (string) — optional
              - `max_gram` (number) — optional
              - `min_gram` (number) — optional
              - `token_chars` (enum[] · default: []) — optional
                Values: `letter`, `digit`, `whitespace`, `punctuation`, `symbol`, `custom`
            - **type: path_hierarchy** (`type: path_hierarchy`)
              - `type` (enum) — required
                Values: `path_hierarchy`
              - `version` (string) — optional
              - `buffer_size` (number | string) — optional
              - `delimiter` (string) — optional
              - `replacement` (string) — optional
              - `reverse` (boolean | string) — optional
              - `skip` (number | string) — optional
            - **type: pattern** (`type: pattern`)
              - `type` (enum) — required
                Values: `pattern`
              - `version` (string) — optional
              - `flags` (string) — optional
              - `group` (number) — optional
              - `pattern` (string) — optional
            - **type: simple_pattern** (`type: simple_pattern`)
              - `type` (enum) — required
                Values: `simple_pattern`
              - `version` (string) — optional
              - `pattern` (string) — optional
            - **type: simple_pattern_split** (`type: simple_pattern_split`)
              - `type` (enum) — required
                Values: `simple_pattern_split`
              - `version` (string) — optional
              - `pattern` (string) — optional
            - **type: standard** (`type: standard`)
              - `type` (enum) — required
                Values: `standard`
              - `version` (string) — optional
              - `max_token_length` (number) — optional
            - **type: thai** (`type: thai`)
              - `type` (enum) — required
                Values: `thai`
              - `version` (string) — optional
            - **type: uax_url_email** (`type: uax_url_email`)
              - `type` (enum) — required
                Values: `uax_url_email`
              - `version` (string) — optional
              - `max_token_length` (number) — optional
            - **type: whitespace** (`type: whitespace`)
              - `type` (enum) — required
[...]
